<template>
   <div class="select-wrapper">
      <el-select
         v-model="valueOfSportObject"
         class="m-2"
         placeholder="Wybierz obiekt sportowy"
         clearable
         style="width: 240px"
         @change="
            () => {
               updateColor(store.sportObject.find((element) => element.name === valueOfSportObject)?.color || '')
               store.filter.sport_object = valueOfSportObject || ''
            }
         "
      >
         <el-option
            v-for="sportObject in sportObjects"
            :key="sportObject.id"
            :label="sportObject.name"
            :value="sportObject.name"
         />
      </el-select>
      <el-select
         v-model="valueOfGroup"
         class="m-2"
         placeholder="Wybierz grupę "
         clearable
         style="width: 240px"
         @change="
            () => {
               updateColor(store.groups.find((element) => element.name === valueOfGroup)?.color || '')
               store.filter.group = valueOfGroup || ''
            }
         "
      >
         <el-option v-for="group in groups" :key="group.id" :label="group.name" :value="group.name" />
      </el-select>
      <div>
         <input id="showHistory" v-model="checked" type="checkbox" @click="showHistory" />
         <label for="showHistory">Pokaż historię</label>
      </div>
   </div>
</template>

<script setup lang="ts">
import { ref, defineEmits } from "vue"
import { useReservation } from "@/views/reservations/store.ts"
import { type ISportObject, type IGroup } from "@/views/reservations/store.ts"

const sportObjects: ISportObject[] = []
const valueOfSportObject = ref<string>(""),
   valueOfGroup = ref<string>(""),
   store = useReservation(),
   checked = ref<boolean>(false),
   groups: IGroup[] = [],
   emit = defineEmits(["showHistory", "changeColorBlock"])

store.sportObject.forEach((element) => {
   sportObjects.push(element)
})
store.groups.forEach((element) => {
   groups.push(element)
})

function showHistory() {
   emit("showHistory", checked.value)
}

function updateColor(color: string) {
   if (color != "") {
      emitChangeColor(color)
   } else {
      emitChangeColor("var(--yellow-2)")
   }
}

function emitChangeColor(color: string) {
   emit("changeColorBlock", color)
}
</script>
